package de.fraunhofer.iem.dataprovider.dependency.entity

import jakarta.persistence.*
import org.hibernate.Hibernate
import java.util.*

@Entity
@Table(name = "dependency")
class DependencyEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null

    @Column(name = "name", length = 600)
    var name: String? = null

    @OneToMany(
        mappedBy = "dependency",
        cascade = [CascadeType.ALL],
        orphanRemoval = true
    )
    var vulnerabilities: MutableSet<VulnerabilityEntity> = mutableSetOf()
    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as DependencyEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}