package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.odc

import de.fraunhofer.iem.dataprovider.taskManager.events.Event
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.SarifTask
import de.fraunhofer.iem.dataprovider.toolRun.service.ToolRunService
import org.springframework.core.io.ClassPathResource
import org.springframework.core.io.Resource
import java.nio.file.Files
import java.nio.file.Path
import java.nio.file.Paths
import java.util.*

class OdcTask(
    projectPath: String, outputPath: String,
    override val responseChannel: suspend (task: Event) -> Unit,
    override val repoId: UUID,
    override val groupID: UUID? = null,
    override val toolRunService: ToolRunService
) : SarifTask() {

    private val resource: Resource = ClassPathResource("scripts/odc.sh")
    override val flags: Array<String> = arrayOf(resource.file.absolutePath, outputPath, projectPath)
    override val resultPath: Path = Paths.get(outputPath, "odc", "dependency-check-report.sarif")

    init {
        Files.createDirectories(Paths.get(outputPath, "odc"))
    }
}
