package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.qodana

import de.fraunhofer.iem.dataprovider.taskManager.events.Event
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.qodana.json.getQodanaSarifFromFilePath
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.SarifTask
import de.fraunhofer.iem.dataprovider.toolRun.service.ToolRunService
import org.springframework.core.io.ClassPathResource
import org.springframework.core.io.Resource
import java.nio.file.Files
import java.nio.file.Path
import java.nio.file.Paths
import java.util.*


class QodanaTask(
    projectPath: String, outputPath: String,
    override val responseChannel: suspend (task: Event) -> Unit,
    override val repoId: UUID,
    override val groupID: UUID? = null,
    override val toolRunService: ToolRunService
) : SarifTask() {

    private val resource: Resource = ClassPathResource("scripts/qodana.sh")
    override val flags: Array<String> =
        arrayOf(resource.file.absolutePath, projectPath, Paths.get(outputPath, "qodana").toString())
    override val resultPath: Path = Paths.get(outputPath, "qodana", "qodana.sarif.json")

    override val getSarif = ::getQodanaSarifFromFilePath

    init {
        Files.createDirectories(Paths.get(outputPath, "qodana"))
    }
}