package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif

import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.ToolProcessTask
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json.SarifJson
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json.getSarifFromFilePath
import de.fraunhofer.iem.dataprovider.toolRun.service.ToolRunService
import java.nio.file.Path

abstract class SarifTask : ToolProcessTask<SarifJson>() {

    protected abstract val toolRunService: ToolRunService
    protected open val getSarif = ::getSarifFromFilePath


    override suspend fun parseProcessResults(resultPath: Path): SarifJson {
        return getSarif(resultPath)
    }

    override suspend fun storeResultsInDb(result: SarifJson) {
        toolRunService.createToolRunFromSarif(result, repoId)
    }
}
