package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json

import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable
import kotlinx.serialization.decodeFromString
import kotlinx.serialization.json.Json
import java.io.IOException
import java.nio.file.Path


@Serializable
data class SarifJson(
    @SerialName("runs")
    val runs: List<SarifRunJson>
)

fun getSarifFromFilePath(resultPath: Path): SarifJson {
    val resFile = resultPath.toFile()
    if (resFile.exists()) {
        val resString = resFile.readText()
        val json = Json { ignoreUnknownKeys = true }
        return json.decodeFromString<SarifJson>(resString)
    }

    throw IOException("File not found / Path is no file.")
}
