package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json

import de.fraunhofer.iem.dataprovider.toolRun.entity.LocationEntity
import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable

@Serializable
data class SarifLocationJson(
    @SerialName("physicalLocation")
    val physicalLocation: SarifPhysicalLocationJson
)

fun SarifLocationJson.asDbObject(): LocationEntity {
    val locationEntity = LocationEntity()
    locationEntity.endColumn = this.physicalLocation.region?.endColumn ?: -1
    locationEntity.endLine = this.physicalLocation.region?.endLine ?: -1
    locationEntity.startColumn = this.physicalLocation.region?.startColumn ?: -1
    locationEntity.startLine = this.physicalLocation.region?.startLine ?: -1
    locationEntity.artifactLocation = this.physicalLocation.artifactLocation.uri
    return locationEntity
}