package de.fraunhofer.iem.dataprovider.tool.entity

import de.fraunhofer.iem.dataprovider.toolRun.entity.FindingEntity
import de.fraunhofer.iem.dataprovider.toolRun.entity.ToolRunEntity
import jakarta.persistence.*
import org.hibernate.Hibernate
import java.util.*

@Entity
@Table(name = "rule")
class RuleEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null


    @Column(name = "sarif_rule_id")
    var sarifRuleId: String? = null

    @Column(name = "short_description", columnDefinition = "TEXT")
    var shortDescription: String? = null

    @OneToMany(
        mappedBy = "rule",
        cascade = [CascadeType.MERGE, CascadeType.REFRESH, CascadeType.REFRESH, CascadeType.DETACH],
        orphanRemoval = true
    )
    var findings: MutableSet<FindingEntity> = mutableSetOf()

    @ManyToOne
    var toolRun: ToolRunEntity? = null

    fun addResultLocations(findingEntities: Collection<FindingEntity>) {
        findingEntities.forEach {
            this.addResultLocation(it)
        }
    }

    fun addResultLocation(findingEntity: FindingEntity) {
        findings.add(findingEntity)
        findingEntity.rule = this
    }

    @ElementCollection
    @CollectionTable(name = "rule_messages", joinColumns = [JoinColumn(name = "owner_id")])
    @Column(name = "message", length = 1000)
    var messages: MutableList<String> = mutableListOf()

    @ManyToOne
    var tool: ToolEntity? = null

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as RuleEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}