package de.fraunhofer.iem.dataprovider.dependency.dto

import de.fraunhofer.iem.dataprovider.dependency.entity.VulnerabilityEntity

data class VulnerabilityCreateDto(
    val cveIdentifier: String,
    val vulnerabilityScore: List<VulnerabilityScoreCreateDto> = mutableListOf()
) {
    fun toDbObject(): VulnerabilityEntity {
        val vulnerabilityEntity = VulnerabilityEntity()
        vulnerabilityEntity.cveIdentifier = this.cveIdentifier

        vulnerabilityEntity.vulnerabilityScores = this.vulnerabilityScore.map { score ->
            val score = score.toDbObject()
            score.vulnerability = vulnerabilityEntity
            score
        }.toMutableSet()

        return vulnerabilityEntity
    }
}
